UseMB=1	; use MasmBasic (deb macro, Print Str$(ST(0))....)
if UseMB
	include \masm32\MasmBasic\MasmBasic.inc
else
	.nolist
	include \masm32\include\masm32rt.inc
endif

.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
SleepMs = 50		; test if anything changes when changing this
LOOP_COUNT = 1000000/10	; One Mio would be a typical value

DotXMM1Acc4E	PROTO :DWORD, :DWORD, :DWORD
DotXMM1Acc4EJ1	PROTO :DWORD, :DWORD, :DWORD
DotXMM1Acc4EJ2	PROTO :DWORD, :DWORD, :DWORD

MakeData MACRO SrcName, firstvalue
LOCAL tc
  .data
  align 16
  &SrcName& LABEL REAL4
	tc = firstvalue
	REPEAT 128*4
		tmp$ CATSTR <REAL4 >, %tc, <.0>
		REPEAT 15
			tc = tc + 1
			tmp$ CATSTR tmp$, <, >, %tc, <.0>
		ENDM
		tmp$
;		% echo tmp$
		tc = tc + 1
	ENDM
	tmp$
  .code
ENDM

.data?
Res4	REAL4 ?

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level

	MakeData SrcX, 1
	MakeData SrcY, 2

	REPEAT 3	; ####### start of timings #######
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke DotXMM1Acc4E, offset SrcX, offset SrcY, 2048
				fstp Res4
		counter_end
		print str$(eax), 9, "cycles for DotXMM1Acc4E", 13, 10

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke DotXMM1Acc4EJ1, offset SrcX, offset SrcY, 2048
				fstp Res4
		counter_end
		print str$(eax), 9, "cycles for DotXMM1Acc4EJ1", 13, 10

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke DotXMM1Acc4EJ2, offset SrcX, offset SrcY, 2048
				fstp Res4
		counter_end
		print str$(eax), 9, "cycles for DotXMM1Acc4EJ2", 13, 10

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
        			push 2048
	        		push offset SrcY
		        	push offset SrcX
				call AxDotXMM1_cdecl
                                add esp,12
				fstp Res4
		counter_end
		print str$(eax), 9, "cycles for AxDotXMM1_cdecl", 13, 10

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				push 2048
				mov edx,offset SrcY
				mov ecx,offset SrcX
				call AxDotXMM1_fastcall
				fstp Res4
		counter_end
		print str$(eax), 9, "cycles for AxDotXMM1_fastcall", 13, 10

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
        			push 2048
	        		push offset SrcY
		        	push offset SrcX
				call DotXMM2Acc16ELingo
				fstp Res4
		counter_end
		print str$(eax), 9, "cycles for DotXMM2Acc16ELingo", 13, 10

		print chr$(13, 10)
	ENDM	; ####### end of timings #######

		if UseMB
			invoke DotXMM1Acc4E, offset SrcX, offset SrcY, 2048
			fstp Res4
			Print Str$("\nThe result for DotXMM1Acc4E:\t\t %i", Res4)

			invoke DotXMM1Acc4EJ1, offset SrcX, offset SrcY, 2048
			fstp Res4
			Print Str$("\nThe result for DotXMM1Acc4EJ1:\t\t %i", Res4)

			invoke DotXMM1Acc4EJ2, offset SrcX, offset SrcY, 2048
			fstp Res4
			Print Str$("\nThe result for DotXMM1Acc4EJ2:\t\t %i", Res4)

                        push 2048
                        push offset SrcY
                        push offset SrcX
                        call AxDotXMM1_cdecl
                        add esp,12
                        fstp Res4
			Print Str$("\nThe result for AxDotXMM1_cdecl:\t\t %i", Res4)

                        push 2048
                        mov edx,offset SrcY
                        mov ecx,offset SrcX
                        call AxDotXMM1_fastcall
                        fstp Res4
			Print Str$("\nThe result for AxDotXMM1_fastcall:\t %i", Res4)

			push 2048
			push offset SrcY
			push offset SrcX
			call DotXMM2Acc16ELingo
			fstp Res4
			Print Str$("\nThe result for DotXMM2Acc16ELingo:\t %i", Res4)
		endif
	inkey chr$(13, 10, "--- done ---", 13)
	exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16
; if __cdecl version will be maked, then add before proc start the 8 NOPs (for main loop alignment by mod16).
;Purpose:	Compute the dot product with SSE instructions.
;Input:		[esp+4]  = pointer to X
;		[esp+8]  = pointer to Y
;		[esp+12] = n (# of array elements)
;Output:	Dot product
;
;Other details:
;	Calling convention: Microsoft-fastcall
;	If proc(edure) aligned by 16bytes boundary, then main loop also aligned by 16bytes boundary
;	Main loop have length 16bytes.
;	Code size - 60 bytes.
;
;	If needed other calling convention for using, then can be used
;	thunkers below main code: AxDotXMM1_stdcall and AxDotXMM1_cdecl.
;	Or code can be slightly changed itself -
;	for support __cdecl, read comments please.
;
; One accumulator - 16 elements per loop
; Final repacking for addition of all FLOATs is not changed - it seems to be fastest
; on my machine.
AxDotXMM1_fastcall	proc SYSCALL	arrX:DWORD,arrY:DWORD,arrSize:DWORD

	;##################################################
	; For making this code __cdecl itself, read comments
	; uncomment next 3 lines
	;mov ecx,[esp+4]	; arrX already in ECX
	;mov edx,[esp+8]	; arrY already in EDX
	;mov eax,[esp+12]	; comment line below, because other stack layout for __cdecl and __stdcall
	mov eax,[esp+4]		; get size of arrays

	xorps xmm0,xmm0
	shl eax,2
	add ecx,eax		;\ pointers to behind arrays
	add edx,eax		;/
	neg eax			; make counter negative, for forwarding load from memory...
	@@:
	movaps xmm1,[eax+ecx]	; ...and simple usaging in the loop
	mulps xmm1,[eax+edx]
	addps xmm0,xmm1
	add eax,16
	jne short @B		; two instr for loop, loop has length 16bytes!
	movhlps xmm1,xmm0
	addps xmm0,xmm1
	pshufd xmm1,xmm0,01
	addss xmm0,xmm1
	movd dword ptr [esp+4],xmm0
	fld dword ptr [esp+4]
	
	ret 4	; !!!!! for __cdecl change "ret 4" to "retn"
AxDotXMM1_fastcall	endp


; STDCALL thunker
AxDotXMM1_stdcall	proc STDCALL	arrX:DWORD,arrY:DWORD,arrSize:DWORD
	pop eax		; leave third arg on stack only...
	pop ecx
	pop edx
	push eax
	jmp AxDotXMM1_fastcall	; after return from fastcall version, third arg will be removed correctly
AxDotXMM1_stdcall	endp

; CDECL thunker
AxDotXMM1_cdecl	proc STDCALL	arrX:DWORD,arrY:DWORD,arrSize:DWORD
	pop eax		; repack args, for making fastcall to have no meaning for __cdecl
	mov ecx,[esp]
	mov edx,[esp+4]
	push [esp+8]
	push eax
	jmp AxDotXMM1_fastcall

AxDotXMM1_cdecl	endp


OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

DotXMM1Acc4E proc srcX, srcY, counter
	mov ecx, counter	; [esp+12]		;ecx = n
	mov eax, srcX	; [esp+4]		;eax -> X
	mov edx, srcY	; [esp+8]		;edx -> Y
	pxor xmm7, xmm7	; xmm7 = accumulator for the 4-component vector
	shl ecx, 2	; ecx = 4*n (float)
	sub esp, 4	; stack space for function result
	sub eax, edx	; saves 1 lea instruction inside the main loop
	align 16

@@:	movaps xmm0, [eax+edx]	; xmm0 = X[i+3] X[i+2] X[i+1] X[i+0]
	mulps xmm0, [edx]	; xmm0 = X[i+3]*Y[i+3] X[i+2]*Y[i+2] X[i+1]*Y[i+1] X[i]*Y[i]
	addps xmm7, xmm0	; sum up
	lea edx, [edx+16]	; update pointers
	sub ecx, 16	; count down
	jg @B

	movhlps xmm0, xmm7	; get bits 64 - 127 from xmm7
	addps xmm7, xmm0	; sums in 2 dwords
	pshufd xmm0, xmm7,1	; get bits 32 - 63 from xmm7
	addss xmm7, xmm0	; sum in 1 dword
	movss dword ptr [esp], xmm7	; store sum
	fld dword ptr [esp]	; load function result
	add esp, 4	; adjust stack
	ret
DotXMM1Acc4E endp

DotXMM1Acc4EJ1 proc srcX, srcY, counter
	mov ecx, counter	; [esp+12]		;ecx = n	2048
	mov eax, srcX	; [esp+4]		;eax -> X
	mov edx, srcY	; [esp+8]		;edx -> Y
	pxor xmm7, xmm7	; xmm7 = accumulator for the 4-component vector
	shl ecx, 2	; ecx = 4*n (float)	; ecx=2000h
	sub esp, 4	; stack space for function result
	sub eax, edx	; saves 1 lea instruction inside the main loop eax=2000h
	UseCmp = 1
	repct = 16
	if UseCmp
		add ecx, edx	; slightly faster
	endif
;	int 3	; OPT_Olly 2
	align 16

@@:
	REPEAT repct	; unrolling helps, but make sure that the count is divisible by the rep count!!
		movaps xmm0, [eax+edx]
		mulps xmm0, [edx]
		lea edx, [edx+16]
		addps xmm7, xmm0	; sum up
	ENDM

	if UseCmp
		cmp edx, ecx	; faster, at least on Celeron M
		jb @B
	else
		sub ecx, 16*repct	; count down
		jg @B
	endif

	movhlps xmm0, xmm7	; get bits 64 - 127 from xmm7
	addps xmm7, xmm0	; sums in 2 dwords
	pshufd xmm0, xmm7,1	; get bits 32 - 63 from xmm7
	addss xmm7, xmm0	; sum in 1 dword
	movss dword ptr [esp], xmm7	; store sum
	fld dword ptr [esp]	; load function result
	add esp, 4	; adjust stack
	ret
DotXMM1Acc4EJ1 endp

DotXMM1Acc4EJ2 proc srcX, srcY, counter
	mov ecx, counter	; [esp+12]		;ecx = n	2048
	mov eax, srcX	; [esp+4]		;eax -> X
	mov edx, srcY	; [esp+8]		;edx -> Y
	pxor xmm7, xmm7	; xmm7 = accumulator for the 4-component vector
	shl ecx, 2	; ecx = 4*n (float)	; ecx=2000h
	sub esp, 4	; stack space for function result
	sub eax, edx	; saves 1 lea instruction inside the main loop eax=2000h
	UseCmp = 1
	repct = 16
	if UseCmp
		add ecx, edx	; slightly faster
	endif
;	int 3	; OPT_Olly 2
	align 16

@@:
	REPEAT repct/4	; unrolling helps, but make sure that the count is divisible by the rep count!!
		movaps xmm0, [eax+edx]
		movaps xmm1, [eax+edx+16]
		movaps xmm2, [eax+edx+32]
		movaps xmm3, [eax+edx+48]
		mulps xmm0, [edx]
		mulps xmm1, [edx+16]
		mulps xmm2, [edx+32]
		mulps xmm3, [edx+48]
		lea edx, [edx+64]
		addps xmm7, xmm0	; sum up
		addps xmm7, xmm1
		addps xmm7, xmm2
		addps xmm7, xmm3
	ENDM

	if UseCmp
		cmp edx, ecx	; faster, at least on Celeron M
		jb @B
	else
		sub ecx, 16*repct	; count down
		jg @B
	endif

	movhlps xmm0, xmm7	; get bits 64 - 127 from xmm7
	addps xmm7, xmm0	; sums in 2 dwords
	pshufd xmm0, xmm7,1	; get bits 32 - 63 from xmm7
	addss xmm7, xmm0	; sum in 1 dword
	movss dword ptr [esp], xmm7	; store sum
	fld dword ptr [esp]	; load function result
	add esp, 4	; adjust stack
	ret
DotXMM1Acc4EJ2 endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16
db 3 Dup(0)
DotXMM2Acc16ELingo proc srcX, srcY, counter
pxor        xmm5,  xmm5
mov         eax,   [esp+1*4] ; eax->srcX
pxor        xmm6,  xmm6
mov         edx,   [esp+2*4] ; edx ->srcY
movaps      xmm0,  [eax]
pxor        xmm4,  xmm4
mov         ecx,   [esp+3*4] ; ecx = counter
sub         eax,   edx
@@:
movaps     xmm1, [eax+edx+16]
mulps    xmm0, [edx]
addps   xmm5, xmm6
movaps     xmm3, [eax+edx+32]
mulps    xmm1, [edx+16]
addps    xmm4, xmm0
movaps     xmm6, [eax+edx+48]
mulps    xmm3, [edx+32]
add    edx,  64
addps     xmm5, xmm1
movaps     xmm0, [eax+edx]
mulps    xmm6, [edx+48-64]
addps   xmm4, xmm3
sub      ecx,  16
ja     @b
addps   xmm4, xmm6
addps   xmm4, xmm5
movhlps   xmm0, xmm4
addps   xmm4, xmm0
pshufd    xmm0, xmm4,1
addss   xmm4, xmm0
movss     dword ptr [esp+2*4], xmm4
fld       dword ptr [esp+2*4]
ret       3*4
DotXMM2Acc16ELingo endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
ShowCpu proc	; mode:DWORD
COMMENT @ Usage:
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
OPT_Olly	2

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]
